<?php
// $Id: kudos.views.inc,v 1.1.2.1 2009/09/26 18:59:34 tjwnyc Exp $
/**
 * @file
 * Provide views data and handlers for kudos.module
 */

/**
 * Implementation of hook_views_data()
 */
function kudos_views_data() {
 // Basic table information.

  // ----------------------------------------------------------------
  // node_example table
  //  New group within Views called 'Example'
  //  The group will appear in the UI in the dropdown tha allows you
  //  to narrow down which fields and filters are available.

  $data = array();

  //  Use node_example as a new base table
  //     by creating a new views type called 'Node example'
  //  This allows it to be selected as the 'view type'
  //          when you initially add a new view.
  $data['kudos_cached']['table']['group']  = t('Kudos');

  // Let Views know that our example table joins to the 'node'
  // base table. This means it will be available when listing
  // nodes and automatically make its fields appear.
  //
  // We also show up for node revisions.
  $data['kudos_cached']['table']['join'] = array(
    'node_revisions' => array(
      'left_field' => 'nid',
      'field' => 'content_id',
      'extra' => array(
        array('field' => 'content_type', 'value' => 'node', 'numeric' => FALSE),
      ),
    ),
    'node' => array(
      'left_field' => 'nid',
      'field' => 'content_id',
      'extra' => array(
        array('field' => 'content_type', 'value' => 'node', 'numeric' => FALSE),
      ),
    ),
    'comments' => array(
      'left_field' => 'cid',
      'field' => 'content_id',
      'extra' => array(
        array('field' => 'content_type', 'value' => 'comment', 'numeric' => FALSE),
      ),
    ),
    'users' => array(
      'left_field' => 'uid',
      'field' => 'content_id',
      'extra' => array(
        array('field' => 'content_type', 'value' => 'user', 'numeric' => FALSE),
      ),
    ),
    'kudos_info' => array(
      'left_table' => 'kudos_cached',
      'left_field' => 'kudo_id',
      'field' => 'id',
      'type' => 'INNER', // all kudos must exist in the kudos_info table
    ),
  );

  // period
  $data['kudos_cached']['period'] = array(
    'title' => t('Period'), // The item it appears as on the UI,
    'help' => t('The period of the kudos status'), // The help that appears on the UI,
     // Information for displaying a title as a field
    'field' => array(
      'field' => 'period', // the real field
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
     ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_kudos_period',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_kudos_period',
    ),
  );

  // Num Given
  $data['kudos_cached']['num_given'] = array(
    'title' => t('Number Received'),
    'help' => t('number of kudos received'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
     ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  //Content type
  $data['kudos_cached']['content_type'] = array(
    'title' => t('Content Type'),
    'help' => t('The content type the kudo was given to'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_kudos_content_type',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_kudos_content_type',
    ),
  );

  // Content id
  $data['kudos_cached']['content_id'] = array(
    'title' => t('Content id'),
    'help' => t('the unique id of the content that the kudo was given to'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
     ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  //
  // Let views know how to retrieve info from the kudos info table
  //
  $data['kudos_info']['table']['group']  = t('Kudos');

  $data['kudos_info']['table']['base'] = array(
    'field' => 'id',
    'title' => t('Kudo info'),
    'help' => t('Kudo info details'),
  );

  // Let Views know that our example table joins to the 'node'
  // base table. This means it will be available when listing
  // nodes and automatically make its fields appear.
  //
  // We also show up for node revisions.
  $data['kudos_info']['table']['join'] = array(
    'kudos_cached' => array(
      'left_field' => 'id',
      'field' => 'kudo_id',
      'type' => 'INNER', // all kudos must exist in the kudos_info table
    ),
    'node_revisions' => array(
      'left_table' => 'kudos_cached',
      'left_field' => 'kudo_id',
      'field' => 'id',
    ),
    'node' => array(
      'left_table' => 'kudos_cached',
      'left_field' => 'kudo_id',
      'field' => 'id',
    ),
    'comments' => array(
      'left_table' => 'kudos_cached',
      'left_field' => 'kudo_id',
      'field' => 'id',
    ),
    'users' => array(
      'left_table' => 'kudos_cached',
      'left_field' => 'kudo_id',
      'field' => 'id',
    ),
  );

  // Kudo Id
  $data['kudos_info']['id'] = array(
    'title' => t('Kudo Id'),
    'help' => t('Id of the kudo given'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
     ),
    'filter' => array(
      'handler' => 'views_handler_filter_kudos_kudo',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  //Kudo Name
  $data['kudos_info']['name'] = array(
    'title' => t('Kudo Name'),
    'help' => t('The name of the kudo received'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_kudos_kudo',
    ),
  );

  //Kudo Label
  $data['kudos_info']['label'] = array(
    'title' => t('Kudo Label'),
    'help' => t('The label of the kudo received'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // published status
  $data['kudos_info']['status'] = array(
    'title' => t('Status'),
    'help' => t('Whether or not the kudo is enabled.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'label' => t('Published'),
      'type' => 'yes-no',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['kudos_info']['icon_give'] = array(
    'field' => array(
      'title' => t('Give Form'),
      'help' => t('Icon to display when giving a kudo'),
      'handler' => 'views_handler_field_kudos_button_active',
    ),
  );

  $data['kudos_info']['icon_view'] = array(
    'field' => array(
      'title' => t('View Icon'),
      'help' => t('Icon to display when viewing user kudos'),
      'handler' => 'views_handler_field_kudos_button_view',
    ),
  );

  //
  // Let views know how to retrieve info from the kudos info table
  //
  $data['kudos_granted']['table']['group']  = t('Kudos');

  $data['kudos_granted']['table']['base'] = array(
    'field' => 'id',
    'title' => t('Kudos granted'),
    'help' => t('Kudo granted details'),
  );

  // Let Views know that our example table joins to the 'node'
  // base table. This means it will be available when listing
  // nodes and automatically make its fields appear.
  //
  // We also show up for node revisions.
  $data['kudos_granted']['table']['join'] = array(
    'node_revisions' => array(
      'left_field' => 'nid',
      'field' => 'content_id',
    ),
    'node' => array(
      'left_field' => 'nid',
      'field' => 'content_id',
    ),
    'comments' => array(
      'left_field' => 'cid',
      'field' => 'content_id',
      'extra' => array(
        array('field' => 'content_type', 'value' => 'comment', 'numeric' => FALSE),
      ),
    ),
    'users' => array(
      'left_field' => 'uid',
      'field' => 'uid',
    ),
    'kudos_info' => array(
      'left_table' => 'kudos_granted',
      'left_field' => 'kudo_id',
      'field' => 'id',
      'type' => 'INNER', // all kudos must exist in the kudos_info table
    ),
  );

  // Kudo grantor uid
  $data['kudos_granted']['uid'] = array(
    'title' => t('Grantor UID'),
    'help' => t('UID of the user who granted the kudo'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
     ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  /*
  //
  //RELATIONSHIP INFO
  //
  $data['kudos_cached']['table']['base'] = array(
    'field' => 'content_id',
    'title' => t('Kudos Cached'),
    'help' => t("Kudos Cached information."),
    'weight' => -9,
  );

  // When using the new 'Node example' type you need to use relationships
  //   to access fields in other tables.

  // Relationship to the 'Node' table
  $data['kudos_cached']['content_id'] = array(
    'title' => t('Node'),
    'help' => t('The particular node the color and quantity is attached to'),
    'relationship' => array(
      'label' => t('Node'),
      'base' => 'node',
      'base field' => 'nid',
      // This allows us to not show this relationship if the base is already
      // node so users won't create circular relationships.
      'skip base' => array('node', 'node_revisions'),
    ),
  );
  */

  return $data;
}


/**
 * Implementation of hook_views_handlers() to register all of the basic handlers
 * views uses.
 */
function kudos_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'kudos') . '/views_handlers',
    ),
    'handlers' => array(
      'views_handler_argument_kudos_period' => array(
        'parent' => 'views_handler_argument',
      ),
      'views_handler_argument_kudos_kudo' => array(
        'parent' => 'views_handler_argument',
      ),
      'views_handler_filter_kudos_period' => array(
        'parent' => 'views_handler_filter_in_operator',
      ),
      'views_handler_filter_kudos_kudo' => array(
        'parent' => 'views_handler_filter_in_operator',
      ),
      'views_handler_field_kudos_button_view' => array(
        'parent' => 'views_handler_field',
      ),
      'views_handler_field_kudos_button_active' => array(
        'parent' => 'views_handler_field',
      ),
      'views_handler_filter_kudos_content_type' => array(
        'parent' => 'views_handler_filter_in_operator',
      ),
      'views_handler_argument_kudos_content_type' => array(
        'parent' => 'views_handler_argument',
      ),
    ),
  );
}
